/////////////////////////////////////////////////////////////////////////////
// GestureManager.cpp: CGestureManager NX̃Cve[V
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GestureManager.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

/////////////////////////////////////////////////////////////////////////////
// \z/
/////////////////////////////////////////////////////////////////////////////

/// ftHgERXgN^
CGestureManager::CGestureManager()
	: m_arrMouseAction()
	, m_arrMouseCommand()
	, m_strSettingFile()
	, m_DrawLine(0)
	, m_MinPixel(0)
	, m_LineColor(0)
{
}

/// RXgN^
CGestureManager::CGestureManager(CString strPath)
{
	// ݒt@C̃pXݒ
	if (strPath.IsEmpty()) {
		m_strSettingFile = AfxGetApp()->m_pszHelpFilePath;
		m_strSettingFile = m_strSettingFile.Left(m_strSettingFile.ReverseFind('\\'));
		m_strSettingFile += m_strSettingFile +	_T("\\option\\gesture.dat");
	} else {
		m_strSettingFile = strPath;
	}
	LoadSetting();
}

/// fXgN^
CGestureManager::~CGestureManager()
{
	m_arrMouseAction.RemoveAll();
	m_arrMouseCommand.RemoveAll();
}

/// WFX`[̕ۑ
void CGestureManager::SaveSetting()
{
	//+++ CStdioFile fin(m_strSettingFile , CFile::modeCreate | CFile::modeWrite);
	CWriteTextFile fin(m_strSettingFile , CFile::modeCreate | CFile::modeWrite);
	for (int i = 0; i < m_arrMouseAction.GetSize(); i++) {
		TCHAR chrCommand[8];
		_itot( m_arrMouseCommand.GetAt(i), &chrCommand[0], 10);

		CString str = m_arrMouseAction.GetAt(i) + _T("\n") + chrCommand + _T("\n");
		fin.WriteString( str );
	}
	fin.Close();
}

/// }EXANṼ[h
void CGestureManager::LoadSetting()
{
	m_arrMouseAction.RemoveAll();
	m_arrMouseCommand.RemoveAll();

	TRY{
		CString str;
		//+++ CStdioFile fin(m_strSettingFile , CFile::modeRead);
		CReadTextFile fin(m_strSettingFile , CFile::modeRead);
		while (fin.ReadString(str)) {
			if (str.GetAt(0)!='L' && str.GetAt(0)!='_')
				str="____ "+str;
			m_arrMouseAction.Add(str);
			fin.ReadString(str);
			m_arrMouseCommand.Add(_ttoi(str));
		}
		fin.Close();
	}
	CATCH( CFileException, e ){
		if ( e->m_cause != CFileException::fileNotFound) {
			TRACE( _T("File could not be opened %d \n")  , e->m_cause);
		}
	}END_CATCH
}

/// C
BOOL CGestureManager::TranslateGesture(MSG* pMsg)
{
	// from DonutP
	if (pMsg->message != WM_RBUTTONDOWN)
		return FALSE;
	// }EXLv`t[
	CFrameWnd*	pFrame = (CFrameWnd*)AfxGetMainWnd();
	HWND 		hWnd   = pFrame->GetSafeHwnd();
	SetCapture(hWnd);

	MSG 		msg;
	msg.message = 0;
	CString 	strMouseCommand= _T("____ ");
	CPoint 		ptRDown( LOWORD(pMsg->lParam) , HIWORD(pMsg->lParam) );
	::ClientToScreen(pMsg->hwnd, &ptRDown);
	CPoint 		ptMove , ptMoveBefore;
	ptMoveBefore = ptRDown;

	// [v
	do{
//		GetMessage(&msg , hWnd , 0 , 0);
//		if (GetCapture() != hWnd)	break;
		if (GetMessage(&msg, NULL, 0, 0) == FALSE) continue;
		//////////////////////////////////////////////////////////////////////
		// ړ
		if (msg.message == WM_MOUSEMOVE) {
			// ݂̃|Cg
			ptMove.x = LOWORD(msg.lParam);
			ptMove.y = HIWORD(msg.lParam);
			::ClientToScreen(msg.hwnd, &ptMove);
			if (abs(ptMoveBefore.x-ptMove.x) >=m_MinPixel ||
				abs(ptMoveBefore.y-ptMove.y)>=m_MinPixel )
			{
				// ͂̔
				CString str= _T("");
				if (abs(ptMove.x-ptMoveBefore.x)>abs(ptMove.y-ptMoveBefore.y)) { // 
					if (ptMove.x-ptMoveBefore.x >0) // E
						str= _T(" ");
					else//
						str= _T(" ");
				}
				else{ // c
					if (ptMove.y-ptMoveBefore.y >0) // 
						str= _T(" ");
					else//
						str= _T(" ");
				}
				if (m_DrawLine)
					DrawLine(ptMoveBefore , ptMove);

				if (strMouseCommand.Right(3)!=str)
					strMouseCommand += str;

				// Xe[^X
				UINT nFlags = UINT(msg.wParam);
				strMouseCommand.SetAt(0 , (nFlags & MK_LBUTTON) ? 'L' :'_');
				strMouseCommand.SetAt(1 , (nFlags & MK_MBUTTON) ? 'M' :'_');
				strMouseCommand.SetAt(2 , (nFlags & MK_SHIFT  ) ? 'S' :'_');
				strMouseCommand.SetAt(3 , (nFlags & MK_CONTROL) ? 'C' :'_');

				ptMoveBefore = ptMove;
				ShowMouseCommand(strMouseCommand);
			}
		}
		else if (msg.message == WM_LBUTTONDOWN) {
			strMouseCommand.SetAt(0, 'L');
			ShowMouseCommand(strMouseCommand);
		}
		else if (msg.message == WM_LBUTTONUP) {
			strMouseCommand.SetAt(0, '_');
			ShowMouseCommand(strMouseCommand);
		}
		else if (msg.message == WM_MBUTTONDOWN) {
			strMouseCommand.SetAt(1, 'M');
			ShowMouseCommand(strMouseCommand);
		}
		else if (msg.message == WM_MBUTTONUP) {
			strMouseCommand.SetAt(1, '_');
			ShowMouseCommand(strMouseCommand);
		}
		else{
			DispatchMessage(&msg);
		}
	}while(msg.message != WM_RBUTTONUP);

	ReleaseCapture();
	// G[ŏI
	if (msg.message != WM_RBUTTONUP)
		return FALSE;

	// Xe[^X
	UINT nFlags = UINT(msg.wParam);
	strMouseCommand.SetAt(0 , (nFlags & MK_LBUTTON) ? 'L' :'_');
	strMouseCommand.SetAt(1 , (nFlags & MK_MBUTTON) ? 'M' :'_');
	strMouseCommand.SetAt(2 , (nFlags & MK_SHIFT  ) ? 'S' :'_');
	strMouseCommand.SetAt(3 , (nFlags & MK_CONTROL) ? 'C' :'_');
	// ĂȂ
	if (strMouseCommand== _T("____ ") ) {
		::PostMessage(pMsg->hwnd , WM_RBUTTONUP , pMsg->wParam , pMsg->lParam);
		return FALSE;
	}
	// ʂXV
	if (m_DrawLine && strMouseCommand.GetLength()>5) {
		pFrame->RedrawWindow(NULL , NULL , RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN);
	}
	// R}hs
	if (DoMouseCommand(strMouseCommand)) { // s
		return TRUE;
	}
	else{ // o^
		// L+RM+RftHgŏ
		if (strMouseCommand.GetLength() == 5)
			::PostMessage(pMsg->hwnd , WM_RBUTTONUP , pMsg->wParam , pMsg->lParam);
		pFrame->SetMessageText( _T("") );
		return FALSE;
	}
	//+++ return TRUE;	//+++ ɂ͗Ȃ.
}

/// 
void CGestureManager::DrawLine(CPoint ptFrom , CPoint ptTo)
{
	AfxGetMainWnd()->ScreenToClient(&ptFrom);
	AfxGetMainWnd()->ScreenToClient(&ptTo);
	CClientDC dc( AfxGetMainWnd() );

	COLORREF color	= m_LineColor;
	CPen 	 pen(PS_SOLID , 1 , color);
	CPen* 	 oldPen = dc.SelectObject(&pen);

	CBrush 	 brush;
	brush.CreateSolidBrush(color);
	CBrush*  oldBrush = dc.SelectObject(&brush);

	dc.MoveTo(ptFrom.x , ptFrom.y);
	dc.LineTo(ptTo.x   , ptTo.y  );
	dc.FillRect(CRect(ptTo.x-2 , ptTo.y-2 , ptTo.x+2 , ptTo.y+2), &brush);

	dc.SelectObject(oldPen);
	dc.SelectObject(oldBrush);
}

/// }EXANV̕\
void CGestureManager::ShowMouseCommand(CString strMouseCommand)
{
	/*
	CString strCommand;
	CIDMap map;
	for (int i = 0;i<m_arrMouseAction.GetSize();i++) {
		if (strMouseCommand == m_arrMouseAction.GetAt(i))
			strCommand+= _T(" [")+ map.Lookup(m_arrMouseCommand.GetAt(i)) + _T("]");
	}
	((CFrameWnd*)AfxGetMainWnd())->SetMessageText(strMouseCommand + strCommand);
	*/
}

/// }EXANV̎s
BOOL CGestureManager::DoMouseCommand(CString strMouseCommand)
{
	for (int i = 0;i<m_arrMouseAction.GetSize();i++) {
		if (strMouseCommand == m_arrMouseAction.GetAt(i)) {
			AfxGetMainWnd()->PostMessage(WM_COMMAND , m_arrMouseCommand.GetAt(i));
			return TRUE;
		}
	}
	return FALSE;
}

/*
CString CGestureManager::ItoStr(int value)
{ // l𕶎
	TCHAR chr[64];
	_itot( value , &chr[0] , 10);
	return chr;
}

void CGestureManager::WriteProfileInt(LPCTSTR strKey , int iValue , LPCTSTR strFile)
{ // iniɏ
	::WritePrivateProfileString( _T("Accelerator")	, strKey , ItoStr(iValue) , strFile);
}
int CGestureManager::GetProfileInt(LPCTSTR strKey , LPCTSTR strFile)
{ // iniɏ
	return ::GetPrivateProfileInt( _T("Accelerator")  , strKey , 0 , strFile);
}
*/
